//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "https://t.me/osama_123"
#property link      "osama.vv@gmail.com"
#property version   "1.6"
#property description "Dynamic Trailing EA"
#property strict

enum Trading_Mode
  {
   DayMode,//Day Mode
   NightMode,//Night Mode
   CustomMode//Custom Mode
  };

enum Drive_Mode
  {
   Hidden,
   Visual
  };

input Drive_Mode DriveMode=Hidden;//Drive Mode
input Trading_Mode TradingMode=DayMode;//Trading Mode
enum Profit_Type
  {
   ByPips,//By Pips
   ByUSD,//By USD $
   Disable//Disable
  };


input Profit_Type ProfitProtectionType=Disable;//Profit Protection Type
input int CustomProfitProtectionStart=25;//Custom Profit Protection Start
input int CustomProfitProtection=5;//Custom Profit Protection

int DayModeProfitProtectionStart=25;
int DayModeProfitProtection=5;
int NightModeProfitProtectionStart=35;
int NightModeProfitProtection=5;


input Profit_Type ManualTargetStopType=Disable;//Manual TP/SL

input int TP=120;//TP in Pips/$
input int SL=40;//SL in pips/$

input bool UseTrailing=false;//Trailing
input int TrailingStart=15;//Trailing Start Pips
input int TrailingStep=1;//Trailing Step

input bool EnableNewsReminder=false;//Enable News Reminder
input int ReminderHoursBeforeNews=1;//Reminder HOurs Before News
input int ReminderMinutesBeforeNews=0;//Reminder Minutes Before News

input color TakeProfitColor=DodgerBlue;//TakeProfit Color
input color StopLossColor=OrangeRed;//StopLoss Color
input color ProfitProtectionColor=Lime;//Profit Protection Color
input color TrailingColor=Gold;//Trailing Color

input bool EnableAlert=false;//Popup Alert
input bool EnableSendMail=false;//Send Mail
input bool EnableNotification=false;//Mobile Notification


datetime Timee;
double point;
int pt;
int Lot_Digits;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(MarketInfo(Symbol(),MODE_MINLOT)<0.1)
      Lot_Digits=2;
   else
      Lot_Digits=1;
   if(_Digits==5 || _Digits==3)
      pt=10;
   else
      pt=1;
   if(_Digits<4)

      point=0.01;
   else
      point=0.0001;

   if(Symbol()=="XAUUSD"||Symbol()=="XAGUSD"||Symbol()=="Gold"||Symbol()=="Silver")
     {
      pt=10;
      point=SymbolInfoDouble(Symbol(),SYMBOL_POINT)*pt;
     }



   Start();
   EventSetTimer(1);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTimer()
  {
   TraceManualTPSL();
   ModifyHiddenTPSLLinesValues();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void)
  {
   Start();
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Start()
  {
   if(ProfitProtectionType!=Disable)
     {
      TraceTradesProfitProtection();
      UpdateTradesProfitProtection();
     }

   TraceManualTPSL();

   if(ManualTargetStopType!=Disable)
     {
      UpdateTradesTPSLTS();
     }

   if(UseTrailing&&TrailingStart>0)
     {
      if(DriveMode==Visual)
         MoveTrailingStop();
      if(DriveMode==Hidden)
        {
         HiddenTrailingStop();
         UpdateTradesTPSLTS();
        }
     }

   ModifyHiddenTPSLLinesValues();

   if(DriveMode==Hidden)
     {
      RemoveOldLine("TPSL");
     }

  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

struct Manual_TPSLTS
  {
   int               ticket;
   double            stopLoss_price;
   double            takeProfit_price;
   double            trailing_price;
  };

Manual_TPSLTS ManualTPSLTS[];




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TraceManualTPSL()
  {
   for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()&&!IsRecordManualTPSLTS(OrderTicket()))
        {
         double new_sl=OrderStopLoss(),new_tp=OrderTakeProfit();

         double sl_in_pips=0,tp_in_pips=0;
         if(ManualTargetStopType==ByPips||ManualTargetStopType==Disable)
           {
            sl_in_pips=SL;
            tp_in_pips=TP;
           }
         if(ManualTargetStopType==ByUSD)
           {
            sl_in_pips=USDToPips(SL,OrderLots());
            tp_in_pips=USDToPips(TP,OrderLots());
           }

         if(new_sl==0&&sl_in_pips!=0)
           {
            if(OrderType()==OP_BUY)
               new_sl=OrderOpenPrice()-sl_in_pips*point;
            if(OrderType()==OP_SELL)
               new_sl=OrderOpenPrice()+sl_in_pips*point;
           }
         if(new_tp==0&&tp_in_pips!=0)
           {
            if(OrderType()==OP_BUY)
               new_tp=OrderOpenPrice()+tp_in_pips*point;
            if(OrderType()==OP_SELL)
               new_tp=OrderOpenPrice()-tp_in_pips*point;
           }

         if(DriveMode==Visual&&ManualTargetStopType!=Disable)
           {
            if((new_sl!=OrderStopLoss()&&OrderStopLoss()==0)||(new_tp!=OrderTakeProfit()&&OrderTakeProfit()==0))
              {
               bool modify=OrderModify(OrderTicket(),OrderOpenPrice(),new_sl,new_tp,0);
              }
           }
         else
            if(DriveMode==Hidden||ManualTargetStopType==Disable)
              {
               AddNewTPSLTS(OrderTicket(),new_tp,new_sl,0);
              }
        }
     }
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void HiddenTrailingStop()
  {
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         double stoploss=0,takeprofit=0,trailing=0;
         GetTradeTPSLTS(OrderTicket(),takeprofit,stoploss,trailing);

         if(OrderType()==OP_BUY)
           {

            if(NormalizeDouble(Ask,Digits)>NormalizeDouble(OrderOpenPrice()+TrailingStart*point,Digits))
              {
               if(trailing+TrailingStep*point<NormalizeDouble(Bid-TrailingStart*point,Digits) ||trailing==0)
                 {
                  AddNewTPSLTS(OrderTicket(),0,0,NormalizeDouble(Bid-TrailingStart*point+TrailingStep*point,Digits));
                 }
              }
           }
         else
            if(OrderType()==OP_SELL)
              {
               if(NormalizeDouble(Bid,Digits)<NormalizeDouble(OrderOpenPrice()-TrailingStart*point,Digits))
                 {
                  if(trailing-TrailingStep*point>NormalizeDouble(Ask+TrailingStart*point,Digits) || trailing==0)
                    {
                     AddNewTPSLTS(OrderTicket(),0,0,NormalizeDouble(Ask+TrailingStart*point-TrailingStep*point,Digits));
                    }
                 }
              }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GetTradeTPSLTS(int ticket,double &takeprofit,double &stoploss,double &trailing)
  {
   int size=ArraySize(ManualTPSLTS);
   for(int i=0; i<size; i++)
     {
      if(ManualTPSLTS[i].ticket==ticket)
        {
         takeprofit=ManualTPSLTS[i].takeProfit_price;
         stoploss=ManualTPSLTS[i].stopLoss_price;
         trailing=ManualTPSLTS[i].trailing_price;
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateTradesTPSLTS()
  {
   for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         double stoploss=0,takeprofit=0,trailing=0;
         GetTradeTPSLTS(OrderTicket(),takeprofit,stoploss,trailing);

         if(stoploss==0&&takeprofit==0&&trailing==0)
            continue;


         if(takeprofit!=0&&ManualTargetStopType!=Disable)
           {
            if(OrderType()==OP_BUY&&Bid>=takeprofit)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Bid,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" reached takeprofit";
               SendMessage(message);
               ExpertRemove();

              }
            if(OrderType()==OP_SELL&&Ask<=takeprofit)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Ask,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" reached takeprofit";
               SendMessage(message);
               ExpertRemove();
              }
           }

         if(stoploss!=0&&ManualTargetStopType!=Disable)
           {
            if(OrderType()==OP_BUY&&Bid<=stoploss)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Bid,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" reached stoploss";
               SendMessage(message);
               ExpertRemove();

              }
            if(OrderType()==OP_SELL&&Ask>=stoploss)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Ask,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" reached stoploss";
               SendMessage(message);
               ExpertRemove();

              }
           }

         if(trailing!=0)
           {
            if(OrderType()==OP_BUY&&Bid<=trailing)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Bid,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" by trailing";
               SendMessage(message);
               ExpertRemove();

              }
            if(OrderType()==OP_SELL&&Ask>=trailing)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),Ask,3*pt);
               string message="Close trade number #"+string(OrderTicket())+" by trailing";
               SendMessage(message);
               ExpertRemove();

              }
           }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyHiddenTPSLLinesValues()
  {
   int size=ArraySize(ManualTPSLTS);
   for(int i=0; i<size; i++)
     {
      string tp_obj="DT_TPSL_tp_"+string(ManualTPSLTS[i].ticket)+"_Hline";
      string sl_obj="DT_TPSL_sl_"+string(ManualTPSLTS[i].ticket)+"_Hline";
      string ts_obj="DT_TPSL_ts_"+string(ManualTPSLTS[i].ticket)+"_Hline";

      double tp_pips=0,sl_pips=0,tp_usd=0,sl_usd=0,ts_pips=0,ts_usd=0;

      if(ObjectFind(tp_obj)>=0)
        {
         double tp_price=ObjectGet(tp_obj,OBJPROP_PRICE1);
         if(tp_price!=ManualTPSLTS[i].takeProfit_price)
           {

            ManualTPSLTS[i].takeProfit_price=tp_price;
            CalculateTradeProfitLoss(ManualTPSLTS[i].ticket,ManualTPSLTS[i].takeProfit_price,ManualTPSLTS[i].stopLoss_price,ManualTPSLTS[i].trailing_price,tp_pips,sl_pips,tp_usd,sl_usd,ts_pips,ts_usd);
            DrawVisibleLine("DT_TPSL_tp_"+string(ManualTPSLTS[i].ticket),ManualTPSLTS[i].takeProfit_price,TakeProfitColor,"Virtual TakeProfit #"+string(ManualTPSLTS[i].ticket),tp_pips,tp_usd);
           }
        }
      if(ObjectFind(sl_obj)>=0)
        {
         double sl_price=ObjectGet(sl_obj,OBJPROP_PRICE1);
         if(sl_price!=ManualTPSLTS[i].stopLoss_price)
           {
            ManualTPSLTS[i].stopLoss_price=sl_price;
            CalculateTradeProfitLoss(ManualTPSLTS[i].ticket,ManualTPSLTS[i].takeProfit_price,ManualTPSLTS[i].stopLoss_price,ManualTPSLTS[i].trailing_price,tp_pips,sl_pips,tp_usd,sl_usd,ts_pips,ts_usd);
            DrawVisibleLine("DT_TPSL_sl_"+string(ManualTPSLTS[i].ticket),ManualTPSLTS[i].stopLoss_price,StopLossColor,"Virtual StopLoss #"+string(ManualTPSLTS[i].ticket),(-1*sl_pips),(-1*sl_usd));
           }
        }
      if(ObjectFind(ts_obj)>=0)
        {
         double ts_price=ObjectGet(ts_obj,OBJPROP_PRICE1);
         if(ts_price!=ManualTPSLTS[i].trailing_price)
           {
            ManualTPSLTS[i].trailing_price=ts_price;
            CalculateTradeProfitLoss(ManualTPSLTS[i].ticket,ManualTPSLTS[i].takeProfit_price,ManualTPSLTS[i].stopLoss_price,ManualTPSLTS[i].trailing_price,tp_pips,sl_pips,tp_usd,sl_usd,ts_pips,ts_usd);
            DrawVisibleLine("DT_TPSL_ts_"+string(ManualTPSLTS[i].ticket),ManualTPSLTS[i].stopLoss_price,TrailingColor,"Virtual Trailing #"+string(ManualTPSLTS[i].ticket),(ts_pips),(ts_usd));

           }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsRecordManualTPSLTS(int ticket)
  {
   int size=ArraySize(ManualTPSLTS);
   for(int i=0; i<size; i++)
     {
      if(ManualTPSLTS[i].ticket==ticket)
        {
         return true;
        }
     }
   return false;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateTradeProfitLoss(int order_ticket,double takeprofit_price,double stoploss_price,double trailing_price,double &tp_pips,double &sl_pips,
                              double &tp_usd,double &sl_usd,double &ts_pips,double &ts_usd)
  {


   bool select=OrderSelect(order_ticket,SELECT_BY_TICKET);
   double lots=OrderLots();
   double open_price=OrderOpenPrice();

   double tick_value=SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*lots*pt;
   if(takeprofit_price!=0)
     {
      tp_pips=MathAbs(open_price-takeprofit_price)/point;
      tp_usd=tp_pips*tick_value;
     }
   if(stoploss_price!=0)
     {
      sl_pips=MathAbs(open_price-stoploss_price)/point;
      sl_usd=sl_pips*tick_value;
     }

   if(trailing_price!=0)
     {
      ts_pips=MathAbs(open_price-trailing_price)/point;
      ts_usd=ts_pips*tick_value;
     }

  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateTradeProfitLoss(double enter_price,double exit_price,double lots,double &pips,double &usd)
  {

   double tick_value=SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*lots*pt;

   pips=MathAbs(enter_price-exit_price)/point;
   usd=pips*tick_value;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CalculateTradeProfitLoss(int order_ticket,double exit_price,double &pips,double &usd)
  {

   bool select=OrderSelect(order_ticket,SELECT_BY_TICKET);
   double lots=OrderLots();
   double open_price=OrderOpenPrice();

   double tick_value=SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*lots*pt;

   pips=MathAbs(open_price-exit_price)/point;
   usd=pips*tick_value;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AddNewTPSLTS(int ticket,double takeprofit_price,double stopLoss_price,double trailing_price)
  {
   double tp_pips=0,sl_pips=0,tp_usd=0,sl_usd=0,ts_pips=0,ts_usd=0;

   CalculateTradeProfitLoss(ticket,takeprofit_price,stopLoss_price,trailing_price,tp_pips,sl_pips,tp_usd,sl_usd,ts_pips,ts_usd);


   if(takeprofit_price!=0)
      DrawVisibleLine("DT_TPSL_tp_"+string(ticket),takeprofit_price,TakeProfitColor,"Virtual TakeProfit #"+string(ticket),tp_pips,tp_usd);
   if(stopLoss_price!=0)
      DrawVisibleLine("DT_TPSL_sl_"+string(ticket),stopLoss_price,StopLossColor,"Virtual StopLoss #"+string(ticket),(-1*sl_pips),(-1*sl_usd));
   if(trailing_price!=0)
      DrawVisibleLine("DT_TPSL_ts_"+string(ticket),trailing_price,TrailingColor,"Virtual Trailing #"+string(ticket),ts_pips,ts_usd);

   bool is_found=false;
   int size=ArraySize(ManualTPSLTS);
   for(int i=0; i<size; i++)
     {
      if(ManualTPSLTS[i].ticket==ticket)
        {
         is_found=true;

         if(takeprofit_price!=0)
            ManualTPSLTS[i].takeProfit_price=takeprofit_price;
         if(stopLoss_price!=0)
            ManualTPSLTS[i].stopLoss_price=stopLoss_price;
         if(trailing_price!=0)
            ManualTPSLTS[i].trailing_price=trailing_price;
        }
     }

   if(is_found)
      return;

   size=ArraySize(ManualTPSLTS);
   ArrayResize(ManualTPSLTS,size+1);
   ManualTPSLTS[size].ticket=ticket;
   if(takeprofit_price!=0)
      ManualTPSLTS[size].takeProfit_price=takeprofit_price;
   if(stopLoss_price!=0)
      ManualTPSLTS[size].stopLoss_price=stopLoss_price;
   if(trailing_price!=0)
      ManualTPSLTS[size].trailing_price=trailing_price;
  }


struct Protection_Trades
  {
   int                  ticket;
   double               protection_price;
   double               protection_profit;
  };

Protection_Trades ProtectionTrades[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateTradesProfitProtection()
  {
   for(int cnt=OrdersTotal()-1; cnt>=0; cnt--)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         double protection=GetTradeProtectionProfit(OrderTicket());
         if(protection==-1)
            continue;

         double profit_usd=OrderProfit()+OrderCommission()+OrderSwap();
         double profit_pips=(OrderType()==OP_BUY?(Bid-OrderOpenPrice()):(OrderOpenPrice()-Ask))/point;
         double profit=0;
         if(ProfitProtectionType==ByPips)
            profit=profit_pips;
         else
            profit=profit_usd;

         if(profit<=protection)
           {
            if(OrderType()==OP_BUY)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,_Digits),3*pt);
               string message="Close trade number #"+string(OrderTicket())+" by profit protection";
               SendMessage(message);
               ExpertRemove();
              }
            if(OrderType()==OP_SELL)
              {
               bool close=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,_Digits),3*pt);
               string message="Close trade number #"+string(OrderTicket())+" by profit protection";
               SendMessage(message);
               ExpertRemove();
              }
           }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetTradeProtectionProfit(int ticket)
  {
   int size=ArraySize(ProtectionTrades);
   for(int i=0; i<size; i++)
     {
      if(ProtectionTrades[i].ticket==ticket)
         return ProtectionTrades[i].protection_profit;
     }
   return -1;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void AddTradeProtection(int order_type,int ticket,double new_protected_price,double protection_profit)
  {
   bool is_found=false;
   int size=ArraySize(ProtectionTrades);
   double pips=0,usd=0;
   for(int i=0; i<size; i++)
     {
      if(ProtectionTrades[i].ticket==ticket)
        {
         is_found=true;
         if(order_type==OP_BUY)
           {
            if(new_protected_price>ProtectionTrades[i].protection_price)
              {
               ProtectionTrades[i].protection_price=new_protected_price;
               ProtectionTrades[i].protection_profit=protection_profit;
               CalculateTradeProfitLoss(ticket,new_protected_price,pips,usd);
               DrawVisibleLine("DT_Protection_"+string(ticket),new_protected_price,ProfitProtectionColor,"Protection Price,  ticket#"+string(ticket),pips,usd);
               string message="Update trade number #"+string(ticket)+" profit protection Price @"+DoubleToStr(new_protected_price,Digits);
               SendMessage(message);
              }
           }
         if(order_type==OP_SELL)
           {
            if(new_protected_price<ProtectionTrades[i].protection_price)
              {
               ProtectionTrades[i].protection_price=new_protected_price;
               ProtectionTrades[i].protection_profit=protection_profit;
               CalculateTradeProfitLoss(ticket,new_protected_price,pips,usd);
               DrawVisibleLine("DT_Protection_"+string(ticket),new_protected_price,ProfitProtectionColor,"Protection Price,  ticket#"+string(ticket),pips,usd);
               string message="Update trade number #"+string(ticket)+" profit protection Price @"+DoubleToStr(new_protected_price,Digits);
               SendMessage(message);
              }
           }
        }
     }

   if(is_found)
      return;

   size=ArraySize(ProtectionTrades);
   ArrayResize(ProtectionTrades,size+1);
   ProtectionTrades[size].ticket=ticket;
   ProtectionTrades[size].protection_price=new_protected_price;
   ProtectionTrades[size].protection_profit=protection_profit;
   CalculateTradeProfitLoss(ticket,new_protected_price,pips,usd);
   DrawVisibleLine("DT_Protection_"+string(ticket),new_protected_price,ProfitProtectionColor,"Protection Price,  ticket#"+string(ticket),pips,usd);
   string message="Update trade number #"+string(ticket)+" profit protection Price @"+DoubleToStr(new_protected_price,Digits);
   SendMessage(message);

  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TraceTradesProfitProtection()
  {
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         double profit_usd=OrderProfit()+OrderCommission()+OrderSwap();
         double profit_pips=(OrderType()==OP_BUY?(Bid-OrderOpenPrice()):(OrderOpenPrice()-Ask))/point;
         double profit=0;
         double order_lots=OrderLots();
         if(ProfitProtectionType==ByPips)
            profit=profit_pips;
         else
            profit=profit_usd;


         double protected_profit=CurrentLevelProtection(profit);
         if(protected_profit!=-1)
           {
            double protected_pips=0;
            if(ProfitProtectionType==ByPips)
               protected_pips=protected_profit;
            else
               protected_pips=USDToPips(protected_profit,order_lots);
            double new_sl=0;

            if(OrderType()==OP_BUY)
               new_sl=OrderOpenPrice()+protected_pips*point;
            if(OrderType()==OP_SELL)
               new_sl=OrderOpenPrice()-protected_pips*point;
            AddTradeProtection(OrderType(),OrderTicket(),new_sl,protected_pips);
           }
        }
     }

   RemoveOldLine("Protection");
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double USDToPips(double profit,double lots)
  {

   double tick_value=SymbolInfoDouble(Symbol(),SYMBOL_TRADE_TICK_VALUE)*lots*pt;

   double profit_pips=profit/tick_value;
   return profit_pips;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RemoveOldLine(string sub_string)
  {
   int total_obj=ObjectsTotal();
   for(int i=total_obj-1; i>=0; i--)
     {
      string name=ObjectName(i);
      if(StringFind(name,sub_string,0)>=0)
        {
         if(IsTradeOpen(name)==false)
           {
            ObjectDelete(name);
           }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsTradeOpen(string obj_name)
  {
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         if(StringFind(obj_name,string(OrderTicket()),0)>=0)
            return true;
        }
     }
   return false;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CurrentLevelProtection(double profit)
  {

   int profit_protection_start=TradingMode==DayMode?DayModeProfitProtectionStart:TradingMode==NightMode?NightModeProfitProtectionStart:CustomProfitProtectionStart;
   int profit_protection=TradingMode==DayMode?DayModeProfitProtection:TradingMode==NightMode?NightModeProfitProtection:CustomProfitProtection;

   double step_difference=profit_protection_start-profit_protection;
   double profit_step=MathFloor(profit/profit_protection_start);
   if(profit_step>0&&profit>=profit_step*profit_protection_start)
     {
      double protect_step=profit_protection_start-profit_protection;
      double protected_profit=(profit_step*profit_protection_start)-protect_step;
      return protected_profit;
     }

   return -1;
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseOrders(int type=-1)
  {
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && (OrderType()==type||type==-1))
        {
         if(OrderType()==OP_BUY)
           {
            bool close=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,_Digits),3*pt);
           }
         if(OrderType()==OP_SELL)
           {
            bool close=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,_Digits),3*pt);
           }
        }
     }
  }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void MoveTrailingStop()
  {
   for(int cnt=0; cnt<OrdersTotal(); cnt++)
     {
      bool select=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
           {
            if(TrailingStart>0 && NormalizeDouble(Ask,Digits)>NormalizeDouble(OrderOpenPrice()+TrailingStart*point,Digits))
              {
               if((NormalizeDouble(OrderStopLoss(),Digits)+TrailingStep*point<NormalizeDouble(Bid-TrailingStart*point,Digits)) || (OrderStopLoss()==0))
                 {
                  bool modify=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-TrailingStart*point+TrailingStep*point,Digits),OrderTakeProfit(),0,Blue);
                 }
              }
           }
         else
            if(OrderType()==OP_SELL)
              {
               if(TrailingStart>0 && NormalizeDouble(Bid,Digits)<NormalizeDouble(OrderOpenPrice()-TrailingStart*point,Digits))
                 {
                  if((NormalizeDouble(OrderStopLoss(),Digits)-TrailingStep*point>(NormalizeDouble(Ask+TrailingStart*point,Digits))) || (OrderStopLoss()==0))
                    {
                     bool modify=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+TrailingStart*point-TrailingStep*point,Digits),OrderTakeProfit(),0,Red);
                    }
                 }
              }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SendMessage(string message)
  {
   if(EnableAlert)
      Alert(message);
   if(EnableSendMail)
      SendMail("Dynamic Trailing Update",message);
   if(EnableNotification)
      SendNotification(message);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawVisibleLine(string name,double price,color col,string text,double pips,double usd)
  {
   string tooltip="Profit: "+DoubleToStr(usd,1)+" "+AccountCurrency()+"\nPips: "+DoubleToStr(pips,1);
   DrawHLine(name+"_Hline",price,col,tooltip);
   if(ManualTargetStopType!=Disable)
      DrawText(name+"_desc",text,Time[20],price,col);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawHLine(string name,double price1,color col,string tooltip,string object_description="",int line_width=1,ENUM_LINE_STYLE line_style=STYLE_SOLID)
  {
   if(ObjectFind(name)==-1)
     {
      ObjectCreate(name,OBJ_HLINE,0,0,price1);
      ObjectSet(name,OBJPROP_COLOR,col);
      ObjectSet(name,OBJPROP_STYLE,line_style);
      ObjectSet(name,OBJPROP_WIDTH,line_width);
      ObjectSet(name,OBJPROP_RAY,false);
      ObjectSetText(name,object_description,9,"Arial",White);
      ObjectSetString(0,name,OBJPROP_TOOLTIP,tooltip);
     }
   else
      if(ObjectGet(name,OBJPROP_PRICE1)!=price1||ObjectGetString(0,name,OBJPROP_TOOLTIP)!=tooltip)
        {
         ObjectSet(name,OBJPROP_PRICE1,price1);
         ObjectSetString(0,name,OBJPROP_TOOLTIP,tooltip);
        }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawText(string name,string text,datetime time,double price,color text_color,int font_size=9,string font_type="Arial")
  {
   if(ObjectFind(name)==-1)
     {
      ObjectCreate(name,OBJ_TEXT,0,time,price);
      ObjectSetText(name,text,font_size,font_type,text_color);
     }
   else
      if(ObjectGet(name,OBJPROP_TIME1)!=time||ObjectGet(name,OBJPROP_PRICE1)!=price||ObjectDescription(text)!=text||ObjectGet(name,OBJPROP_COLOR)!=text_color)
        {
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSet(name,OBJPROP_TIME1,time);
         ObjectSetText(name,text,font_size,font_type,text_color);
        }
  }
//+------------------------------------------------------------------+
